//SExecute
/****************************************************************************** 
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2014. All Rights Reserved.
 *  
 * U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 ******************************************************************************/
/*
 * ExecutionView for Suite
 * Author: vasrivas
 */
dojo.provide("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution");

dojo.require("net.jazz.ajax.ui.PlatformUI");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient");
dojo.require("com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient");
dojo.require("com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole");
dojo.require("com.ibm.rqm.execution.web.ui.internal.util.Utility");
dojo.require("com.ibm.rqm.planning.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.client.internal.Constants");
dojo.require("com.ibm.asq.common.web.ui.internal.util.GlobalEvents");
dojo.require("com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper");
dojo.require("com.ibm.asq.common.web.ui.internal.view.common.CustomAttributesEditor");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout");
dojo.require("com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates");

(function(){ 
	
	var ServiceResponseHandler			= com.ibm.asq.common.web.ui.internal.TransportServiceResponseWrapper;
	var ERGClient 						= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultGroupClient;
	var Constants                       = com.ibm.rqm.planning.web.client.internal.Constants;
	var CommonConstants   				= com.ibm.asq.common.web.client.internal.Constants;
	var Utility 						= com.ibm.rqm.execution.web.ui.internal.util.Utility;
	var GlobalEvents 					= com.ibm.asq.common.web.ui.internal.util.GlobalEvents;
	var ERGMapper						= com.ibm.rqm.execution.web.client.internal.mapper.ExecutionResultGroupMapper;
	var TestExecutionSuiteClient		= com.ibm.rqm.execution.web.client.internal.execution.TestExecutionSuiteClient;
	var customAttrEditor 				= com.ibm.asq.common.web.ui.internal.view.common.CustomAttributesEditor;
	var ConfirmationDialog 				= com.ibm.asq.common.web.ui.internal.widgets.ConfirmationDialog;
	var ViewHeaderLayout				= com.ibm.asq.common.web.ui.internal.view.layout.ViewHeaderLayout;
	var ExecutionResultStates			= com.ibm.rqm.execution.web.client.internal.execution.ExecutionResultStates;
	
	dojo.declare("com.ibm.rqm.execution.web.ui.internal.view.suite.SuiteExecution", [com.ibm.rqm.execution.web.ui.internal.view.common.ExecutionConsole], {
		
		buttonAdded: false,
		consoleNode: false,
		titleSet: false,
		ergName: "",
		initialized: false,
		myURI: null,
		fetchingRequestUpdates: false,

		initialize: function(){
			if(!this.initialized) {
				this.myURI = window.location.hash;
			}
			
			/* if our page is not in view, don't waste the cycle to update the progress.
        	 *  Suspend the refresh until we're in view again.
        	 */
			if(this.myURI != window.location.hash) {
				return;
			}
			
			this._createExecutionTable();
			
			if(!this.initialized){
				console.debug("creating timer");
				this._createTimer();//this._timer = setInterval(dojo.hitch(this, this._fetchRequestUpdates), this.getTimeout());
			}
			if(!this._timer){
				console.debug("creating timer from initialize");
				this._createTimer();//this._timer = setInterval(dojo.hitch(this, this._fetchRequestUpdates), this.getTimeout());
			}
			if (!this.initialized) {
				var responseHandler = new ERGMapper(this, "_setERGroup", "_error");
				this._getERG(responseHandler);
				this.initialized = true;
			}
		},
		
		_getERG: function(responseHandler){
			var args = {};
			if (this.groupId) {
				args.id = this.groupId;
			}
			else if (this.itemId) {
				args.itemId = this.itemId;
			}
			args.includeResult = false;
			args.includeRequest = true;
			args.includeFullTestcase = false; // We need only Testcase Name
			args.includeTestcase = false; // we get it from request
			args.includeTestScript = false; // we get it from the request.
			args.includeCustomAttributes = true;			
			ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
		},
		
		
		_createCustomAttributeSection: function(){
			if(!this.customAttrEditor){
			
				var args = {
		           		parent: this,
		           		scope: "TESTSUITE_RESULT",
		           		existingCustomAttributes: this.resultGroup.customAttributes
		        };
		        this.customAttrEditor = new customAttrEditor(args);
				this.customAttrEditor.domNode.style.width = "40%";
			}	
			this._executionTable.viewHeaderNode.summaryNode.style.display = "inline";	
		},
		
		_showTable: function(requests){
        	this._createTable(requests);
			
			if(!this.showResultButton){
				this.fetchingRequestUpdates = false;
				return;
			}
			
			if (requests && requests[0]) {
				// All requests will have same data for parent erg, so picking it from first request in the row.
				this._checkForCompletion(requests[0].resultGroupStateId);
			}
			else {
				var args = {};
				if (this.groupId) {
					args.id = this.groupId;
				}
				else 
					if (this.itemId) {
						args.itemId = this.itemId;
					}
				args.includeCustomAttributes = false;
				args.includeElements = false;
				args.resolveTestSuite = false;
				args.resolveVariables = false;
				var responseHandler = new ERGMapper(this, "_getERGState", "_error");
				ERGClient.getExecutionResultGroupDTOs(responseHandler, args);
			}
		},
		
		_getERGState: function(ergs){
			if(ergs && ergs[0])
				this._checkForCompletion(ergs[0].state.id);
			else
				this._checkForCompletion(null);
		},

		_setERGroup: function(resultGroup){
			if(resultGroup && resultGroup.length > 0 && resultGroup[0]){
				this.resultGroup = resultGroup[0];
				this.ergId = resultGroup[0].id;
				this.ergName = resultGroup[0].name;
				this._executionTable.setERGId(this.ergId);
				if(!resultGroup[0].sequentialExecution){
					this._executionTable.setSortColAndDir("executionOrder","ASCENDING");
				}
			}
			
			if(this._executionTable && !this.buttonAdded){
				this.buttonAdded = true;
				//Stop button
				this.stopButton = this._executionTable.viewHeaderNode.addRightViewAction(Constants.getMessage("labelStopRun"), dojo.hitch(this, "onStop"), null, null);
				this.stopButton.setDisabled(false);
				//suite result in progress, and pausing flag is set
				//suite is in paused state
				this.pauseButton = this._executionTable.viewHeaderNode.addRightViewAction(Constants.getMessage("labelPause"), dojo.hitch(this, "onPause"), null, null);
				this.pauseButton.setDisabled(false);
				this.resumeButton = this._executionTable.viewHeaderNode.addRightViewAction(Constants.getMessage("labelResume"), dojo.hitch(this, "onResume"), null, null);
				this.resumeButton.setDisabled(false);
				this.showResultButton = this._executionTable.viewHeaderNode.addRightViewAction(Constants.getMessage("labelCloseAndShowResult"), dojo.hitch(this, "onShowResult"), null, null);
				this.showResultButton.setDisabled(true);
			}
			if(this._executionTable && !this.titleSet){
				this.titleSet = true;
				this._executionTable.viewHeaderNode.setTitle(Constants.getMessage("labelTestSuiteExecution", this.ergName));
				this._executionTable.viewHeaderNode.setCSHelpId("rqm_suite_execution_overview.html");
				this._executionTable.viewHeaderNode.setIconClass("ser-icon-48");
			}
			
			if(this.resultGroup){
				if(this.resultGroup.state && this.resultGroup.state.id == ExecutionResultStates.PAUSED){
					this.setStatus(Constants.getMessage("msgSuiteIsPaused"), ViewHeaderLayout.INFO);
					this._hidePauseButton();
				}else if(this.resultGroup.pausing && this.resultGroup.state.id == ExecutionResultStates.IN_PROGRESS){
					this.setStatus(Constants.getMessage("msgSuiteIsBeingPaused"), ViewHeaderLayout.INFO, Constants.getMessage("msgPauseWaitingForTestToComplete"));
					this._hideResumeButton();
					this.pauseButton.setDisabled(true);
				}else{
					this.clearStatus();
					this._hideResumeButton();
				}
				if(this.resultGroup.state && (this.resultGroup.state.id != ExecutionResultStates.PAUSED && this.resultGroup.state.id != ExecutionResultStates.IN_PROGRESS)){
					//The test is neither paused nor in-progress, so user should not be allowed to stop the test.
					//This state will occur if the user through some way reaches the suite console after marking the ERG state complete.
					this.stopButton.setDisabled(true);
				}
			}
			setTimeout(dojo.hitch(this,"_createCustomAttributeSection"), 10);//Keep the section ready for later

			// update browser title
			this._updateBrowserTitle();
		},
		
		_checkForCompletion: function(ergState){
			var completion = false;
			
			if(ergState && ergState != "com.ibm.rqm.execution.common.state.inprogress")
				completion = true;
			
			if(ergState == ExecutionResultStates.PAUSED){
				//The suite was in pausing state and now has completed pause. 
				//Hide pause button and enable resume.
				this._hidePauseButton();
				this.setStatus(Constants.getMessage("msgSuiteIsPaused"), ViewHeaderLayout.INFO);
			}
			
			if(completion){
				var responseHandler = new ERGMapper(this, "_handleCompletion", "_error");
				this._getERG(responseHandler);
			}else{
				if (!this._timer) {
					this._createTimer();
					console.debug("creating timer");
				}
				this._enabledResultButton = false;
				this.showResultButton.setDisabled(true);
				this._refreshErgExecutionStatus();
				this.fetchingRequestUpdates = false;
			}
		},
		
		_handleCompletion: function(resultGroups){
			this.resultGroup = resultGroups[0];
			if(this.customAttrEditor){
				this.customAttrEditor.setAttributes(this.resultGroup.customAttributes);
			}
			this.resultGroupId = this.resultGroup.id;
            if (this._timer) {
            	this._deleteTimer();
                console.debug("deleting timer");
            }
            this.showResultButton.setDisabled(false);
			this._enabledResultButton = true;
			this._executionTable.viewHeaderNode.getSummaryNode().appendChild(this.customAttrEditor.domNode);
			if(this.resultGroup.state.id != ExecutionResultStates.PAUSED){
				//done with execution, disable actions
				this.pauseButton.setDisabled(true);
				this.resumeButton.setDisabled(true);
				this.stopButton.setDisabled(true);
			}
			this._refreshErgExecutionStatus();
			this.fetchingRequestUpdates = false;	
		},
		
		getTimeout: function(){
			return 10000;
		},
		
		_validateCustomAttributes: function(callbackFunction){
			//need to validate first and then call closure
			if(this.customAttrEditor){
				var validationResult= this.customAttrEditor.validate();
				if(!validationResult.status){
					var message = Constants.getMessage("msgMissingReqdAttrForSuiteExecutionResult");
					message = message + validationResult.msg;
					this._displayAlertDialog(message);
					return false;
				}else{
					var params = {
						id: this.resultGroupId
					};
					if(this.customAttrEditor){
						params.customAttributesJson =  dojo.toJson(this.customAttrEditor.getAttributes());
					}
					var callback = {
						success: function(erg){
							console.debug("updated custom attributes for erg");
							if(dojo.isFunction(callbackFunction))
								callbackFunction();
						},
						failure: function(){
							console.error("failed to update custom attributes for erg, stil navigating");
							if(dojo.isFunction(callbackFunction))
								callbackFunction();
						}
					};
					var responseHandler = new ServiceResponseHandler(callback, "success", "failure");			
					ERGClient.postExecutionResultGroup(responseHandler, params);
					return true;
				}
			}
		},
		
		setStatus: function(status, icon, details){
			this._executionTable.viewHeaderNode.setStatus(status, icon, details);
		},
		
		clearStatus: function(){
			this._executionTable.viewHeaderNode.clearStatus();
		},
		
		onStop: function(){
			var confirmDialog = new ConfirmationDialog({
                message: Constants.getMessage("labelConfirmStop"),
                primaryTitle: Constants.getMessage("labelConfirmation"),
                okCallback: dojo.hitch(this, "_processStop")
            });
            confirmDialog.open();
		},
		
		_processStop: function(){
			this.stopButton.setDisabled(true);
			this.setStatus(Constants.getMessage("msgSuiteIsBeingStopped"), ViewHeaderLayout.INFO);
			var args = {
					id: this.ergId
			};
			var responseHandler = new ERGMapper(this, "_processStopComplete", "_processStopFailed");
			ERGClient.postCancelExecution(responseHandler, args);
		},
		
		_processStopComplete: function(erg){
			this._setERGroup(erg);
			this.pauseButton.setDisabled(true);
			this.resumeButton.setDisabled(true);
			this.setStatus(Constants.getMessage("msgSuiteIsStopped"), ViewHeaderLayout.INFO);
			this._fetchRequestUpdates();
		},
		
		_processStopFailed: function(errorObj){
			this._displayAlertDialog(Constants.getMessage("msgSuiteStopFailed")+ errorObj.message);
			this.stopButton.setDisabled(false);
		},
		
		onPause: function(){
			var confirmDialog = new ConfirmationDialog({
                message: Constants.getMessage("labelConfirmPause"),
                primaryTitle: Constants.getMessage("labelConfirmation"),
                okCallback: dojo.hitch(this, "_processPause")
            });
            confirmDialog.open();
		},
		
		_processPause: function(){
			this.setStatus(Constants.getMessage("msgSuiteIsBeingPaused"), ViewHeaderLayout.INFO);
			var args = {
					id: this.ergId
			};
			var responseHandler = new ERGMapper(this, "_processPauseComplete", "_processPauseFailed");
			ERGClient.postPauseExecution(responseHandler, args);
		},
		
		_processPauseComplete: function(erg){
			this._setERGroup(erg);
			if(erg[0].state.id == ExecutionResultStates.PAUSED){
				this._hidePauseButton();
				this.setStatus(Constants.getMessage("msgSuiteIsPaused"), ViewHeaderLayout.INFO);
			}else{
				this.pauseButton.setDisabled(true);
				this.setStatus(Constants.getMessage("msgSuiteIsBeingPaused"), ViewHeaderLayout.INFO,Constants.getMessage("msgPauseWaitingForTestToComplete"));
			}
			this._fetchRequestUpdates();
		},
		
		_processPauseFailed: function(errorObj){
			this._displayAlertDialog(Constants.getMessage("msgSuitePauseFailed")+ errorObj.message);
		},
		
		onResume: function(){
			var confirmDialog = new ConfirmationDialog({
                message: Constants.getMessage("labelConfirmResume"),
                primaryTitle: Constants.getMessage("labelConfirmation"),
                okCallback: dojo.hitch(this, "_processResume")
            });
            confirmDialog.open();
		},
		
		_processResume: function(){
			this.setStatus(Constants.getMessage("msgSuiteIsBeingResumed"), ViewHeaderLayout.INFO);
			var args = {
					id: this.resultGroupId
			};
			var responseHandler = new ERGMapper(this, "_processResumeComplete", "_processResumeFailed");
			ERGClient.postResumeExecution(responseHandler, args);
		},
		
		_processResumeComplete: function(erg){
			this._setERGroup(erg);
			this._fetchRequestUpdates();
			this._hideResumeButton();
			this.clearStatus();
		},
		
		_processResumeFailed: function(errorObj){
			this._displayAlertDialog(Constants.getMessage("msgSuiteResumeFailed")+ errorObj.message);
		},
		
		_hidePauseButton: function(){
			this.pauseButton.setStyle("display", "none");
			this.resumeButton.setStyle("display", "inline");
			this.resumeButton.setDisabled(false);
		},
		
		_hideResumeButton: function(){
			if(this.pauseButton){
				this.pauseButton.setStyle("display", "inline");
				this.pauseButton.setDisabled(false);
			}
			if(this.resumeButton)
				this.resumeButton.setStyle("display", "none");
		},
		
		onShowResult: function(){
			this._validateCustomAttributes(dojo.hitch(this, "_onShowResultPostValidation"));
		},
		
		_onShowResultPostValidation: function(){
			parent.location = Utility.showSuiteResult({id: this.resultGroupId});
			setTimeout(dojo.hitch(this, "publishClosure"), 1500);
		},
		
		publishClosure: function(){
			var args = {};
			if(this.groupId)
				args.groupId = this.groupId;
			if(this.itemId)
				args.itemId = this.itemId;
					
			var uri = Utility.runSuite(args);
			dojo.publish(GlobalEvents.CloseTab, [uri]);
		},
		
		_setClass: function(typeTD, typeLabel, valueTD, valueLabel){
			dojo.addClass(typeTD, "group-field-label");
			dojo.addClass(typeLabel, "attributes-entry-label");
			dojo.addClass(valueTD, "group-field-holder");
			dojo.addClass(valueLabel, "attributes-entry-value");
		},
		
		_updateTopSection: function(){
			var doc = document;
			if(this.topSectionCreated){
				if (this.ergExecutionStatus) {
					var ergStatus = this.ergExecutionStatus;
					var comp = doc.getElementById(this.id+"_completedValue");
					if(comp)	{
						var compText = ergStatus.completed;
						comp.innerHTML = compText;
						comp.setAttribute('aria-label', Constants.getMessage("labelTCCompletedLabel") + " " +  compText);
					}
					
					var run = doc.getElementById(this.id+"_runningValue");
					if(run) {
						var runText = ergStatus.running;
						run.innerHTML = runText;
						run.setAttribute('aria-label', Constants.getMessage("labelTCRunningLabel") + " " +  runText);
					}
					var notRun = doc.getElementById(this.id+"_notRunValue");
					if(notRun) {
						var notRunText = ergStatus.notrun;
						notRun.innerHTML = notRunText;
						notRun.setAttribute('aria-label', Constants.getMessage("labelTCNotRunLabel") + " " +  notRunText);
					}
					if (ergStatus.canceled > 0) {
						var cancel = doc.getElementById(this.id+"_cancelledValue");
						if(cancel) {
							var cancelText = ergStatus.canceled;
							cancel.innerHTML = cancelText;
							cancel.setAttribute('aria-label', Constants.getMessage("labelTCCanceledLabel") + " " +  cancelText);
							dojo.style(this.trCancel, "display", "");
						}
					}
				}
			}else{
				var table = doc.createElement('table');
				table.width = "300px;";
				table.setAttribute( 'role', 'presentation');
				var tbody = doc.createElement('tbody');
				table.appendChild(tbody);
				this._executionTable.viewHeaderNode.getSummaryNode().appendChild(table);
				table.style.marginLeft = "12px";
				
				//tser name and link
				var trName = doc.createElement('tr');
				tbody.appendChild(trName);
				var tdName = doc.createElement('td');
				trName.appendChild(tdName);
				var nameLabel = doc.createElement('label');
				nameLabel.innerHTML = Constants.getMessage("labelSuiteExecutionRecordLabel");
				var tserValueId = this.id+"_nameLink";
				nameLabel.htmlFor =tserValueId;
				tdName.appendChild(nameLabel);
				var tdNameValue = doc.createElement('td');
				trName.appendChild(tdNameValue);
				var anchorName = doc.createElement('a');
				anchorName.id = tserValueId;//Placeholder fetch the suite summary and update
				tdNameValue.appendChild(anchorName);
				this._setClass(tdName, nameLabel, tdNameValue, anchorName);
				
				//Execution Mode
				var seqText = this.resultGroup.sequentialExecution ? Constants.getMessage("labelSequential") : Constants.getMessage("labelParallel");
				var tr = doc.createElement('tr');
				tbody.appendChild(tr);
				var tdtype = doc.createElement('td');
				tr.appendChild(tdtype);
				var typeLabel = doc.createElement('label');
				typeLabel.innerHTML = Constants.getMessage("labelExecutionModeLabel");
				var execModeId = this.id + "_execMode";
				typeLabel.htmlFor = execModeId;
				tdtype.appendChild(typeLabel);
				var tdSeq = doc.createElement('td');
				tr.appendChild(tdSeq);
				var seqLabel = doc.createElement('label');
				seqLabel.id = execModeId;
				seqLabel.setAttribute('aria-label', Constants.getMessage("labelExecutionModeLabel") + " " +  seqText);
				seqLabel.tabIndex = 0;
				seqLabel.innerHTML = seqText;
				tdSeq.appendChild(seqLabel);
				this._setClass(tdtype, typeLabel, tdSeq, seqLabel);
				
				var tr1 = doc.createElement('tr');
				tbody.appendChild(tr1);
				//Completed
				var tdcompLabel = doc.createElement('td');
				tr1.appendChild(tdcompLabel);
				var compLabel = doc.createElement('label');
				var compId = this.id + "_completedValue";
				compLabel.htmlFor = compId;
				compLabel.innerHTML = Constants.getMessage("labelTCCompletedLabel");
				tdcompLabel.appendChild(compLabel);
				var tdcompVal = doc.createElement('td');
				tr1.appendChild(tdcompVal);
				var compVal = doc.createElement('label');
				compVal.innerHTML = "";
				compVal.tabIndex = 0;
				tdcompVal.appendChild(compVal);
				compVal.id = compId;
				this._setClass(tdcompLabel, compLabel, tdcompVal, compVal);
				
				var tr2 = doc.createElement('tr');
				tbody.appendChild(tr2);
				//Running
				var tdrunningLabel = doc.createElement('td');
				tr2.appendChild(tdrunningLabel);
				var runningLabel = doc.createElement('label');
				var runningId =  this.id + "_runningValue";
				runningLabel.htmlFor = runningId;
				runningLabel.innerHTML = Constants.getMessage("labelTCRunningLabel");
				tdrunningLabel.appendChild(runningLabel);
				var tdrunningVal = doc.createElement('td');
				tr2.appendChild(tdrunningVal);
				var runningVal = doc.createElement('label');
				runningVal.tabIndex = 0;
				runningVal.innerHTML = "";
				tdrunningVal.appendChild(runningVal);
				runningVal.id = runningId;
				this._setClass(tdrunningLabel, runningLabel, tdrunningVal, runningVal);
				
				var tr3 = doc.createElement('tr');
				tbody.appendChild(tr3);
				//Not run
				var tdnotRunLabel = doc.createElement('td');
				tr3.appendChild(tdnotRunLabel);
				var notRunLabel = doc.createElement('label');
				var notRunId =  this.id + "_notRunValue";
				notRunLabel.htmlFor = notRunId;
				notRunLabel.innerHTML = Constants.getMessage("labelTCNotRunLabel");
				tdnotRunLabel.appendChild(notRunLabel);
				var tdnotRunVal = doc.createElement('td');
				tr3.appendChild(tdnotRunVal);
				var notRunVal = doc.createElement('label');
				notRunVal.tabIndex = 0;
				notRunVal.innerHTML = "";
				tdnotRunVal.appendChild(notRunVal);
				notRunVal.id =notRunId;
				this._setClass(tdnotRunLabel, notRunLabel, tdnotRunVal, notRunVal);
				
				//Cancelled
				var trCancel = doc.createElement('tr');
				tbody.appendChild(trCancel);
				var tdcanceledLabel = doc.createElement('td');
				trCancel.appendChild(tdcanceledLabel);
				var cancelLabel = doc.createElement('label');
				var cancelId = this.id + "_cancelledValue";
				cancelLabel.htmlFor = cancelId;
				cancelLabel.innerHTML = CommonConstants.getMessage("labelTCCanceledLabel");
				tdcanceledLabel.appendChild(cancelLabel);
				var tdcancelVal = doc.createElement('td');
				trCancel.appendChild(tdcancelVal);
				var cancelVal = doc.createElement('label');
				cancelVal.tabIndex = 0;
				cancelVal.innerHTML = "";
				tdcancelVal.appendChild(cancelVal);
				cancelVal.id = cancelId;
				// Hide by default, show only if suite execution is canceled
				dojo.style(trCancel, "display", "none");
				this.trCancel = trCancel;
				this._setClass(tdcanceledLabel, cancelLabel, tdcancelVal, cancelVal);
				
				this.topSectionCreated = true;
				this._refreshErgExecutionStatus();
				var args = {resultGroupId: this.resultGroup.id, includeArchive: true};
				var responseHandler = new ServiceResponseHandler(this, "_updateSuiteLink", "_error");
				TestExecutionSuiteClient.getTestExecutionSuiteMinimalSummaryDTOs(responseHandler, args);
			}
		},
		
		_updateSuiteLink: function(suiteSummarys){
			var suiteSummary = suiteSummarys ? suiteSummarys[0] : null;
			var anchorName = document.getElementById(this.id+"_nameLink");
			if(anchorName){
				var nameValue = document.createElement('label');
				var linkName = suiteSummary ? suiteSummary.name : this.ergName;
				nameValue.innerHTML = linkName;
				anchorName.setAttribute('aria-label', Constants.getMessage("labelSuiteExecutionRecord") + " " +  linkName);
				anchorName.appendChild(nameValue);
				nameValue.className = 'content-selector-deselected';
				if (suiteSummary){
					anchorName.href = Utility.getSERURI(suiteSummary.id);
				} else{
					anchorName.parentNode.replaceChild(nameValue,anchorName);
				}
			}
		},
	// handler on artifacts changed
    onArtifactChanged: function(changeType, artifactType, artifactArray) {
        // only care about requests
        if (artifactType == Constants.TYPE_REQUEST) {
            if (changeType == GlobalEvents.ArtifactsAdded) {
                // add requests to the table
                if (!this.requests) {
                    this.requests = artifactArray;
                } else {
                    this.requests = this.requests.concat(artifactArray);
                }
            } else {
                // iterate through the array of artifacts
				var len = artifactArray.length;
                for (var i = 0; i < len; i++) {
					var mod = new Date();
					artifactArray[i].modified = mod.getTime();
					var len2 = this.requests.length;
                    // iterate through the array of requests in the table
                    for (var j = 0; j < len2; j++) {
                        // handle the matching requests
                        if (artifactArray[i].id == this.requests[j].id) {
                            if (changeType == GlobalEvents.ArtifactsUpdated) {
                                // swap requests on update
                                this.requests.splice(j, 1, artifactArray[i]);
                            } else if (changeType == GlobalEvents.ArtifactsDeleted) {
                                // remove requests from table on delete
                                this.requests.splice(j, 1);
                            }
                            break;
                        }
                    }
                }
            }
			if (this._executionTable) {
				this._executionTable.setContent(this.requests);
				if(artifactArray && artifactArray[0])
					this._checkForCompletion(artifactArray[0].resultGroupStateId);
			}
        } else if (artifactType == Constants.TYPE_ADAPTER) {
			if (changeType == GlobalEvents.ArtifactsDeleted) {
				if (this._executionTable) {
					this._executionTable._invalidateQuery();
				}
			}
		}
    },
	
    _deleteTimer: function(){
    	clearInterval(this._timer);
		delete this._timer;
    },
    
    _createTimer: function(){
    	if(this._timer){
    		this._deleteTimer();
    	}
    	this._timer = setInterval(dojo.hitch(this, this._fetchRequestUpdates), this.getTimeout());
    },
    
	//Override isDirty to clear Timer on tab close
	isDirty: function(){
		if(this._timer){
			this._deleteTimer();
			console.debug("deleting timer on tab close");
		}
		return false;
	},

	//Over-ride from ExecutionConsole
	_error: function(errorObj){
		if(this._timer){
				this._deleteTimer();
				console.debug("deleting timer");
			}
		this.fetchingRequestUpdates = false;	
		console.error("Error in Suite Execution "+ errorObj.message + " ");
	},
	
	_refreshErgExecutionStatus: function(){
		var args = {};
		if (this.itemId) {
			args.itemId = this.itemId;
		} else if (this.groupId) {
			args.id = this.groupId;
		}
 
		var responseHandler = new ServiceResponseHandler(this, "_successERGStatusUpdate", "_errorERGStatusUpdate");
		ERGClient.getERGStatusDTO(responseHandler, args);
	},
	
	_successERGStatusUpdate: function(ergExecutionStatus) {
		this.ergExecutionStatus = ergExecutionStatus;
		this._updateTopSection();
	},
	
	_errorERGStatusUpdate: function(errorObj) {
		console.error("Error in updating Suite Execution Status "+ errorObj.message + " ");
	},
	
	_fetchRequestUpdates: function(){
		if(this.fetchingRequestUpdates || this.myURI != window.location.hash || !this.resultGroup)
				return;
		this.fetchingRequestUpdates = true;
		this._executionTable.updateSuiteRequests();
	},
	
	onActivated: function(){
		if(this.resultGroup && this.resultGroup.pausing && this.resultGroup.state.id == ExecutionResultStates.IN_PROGRESS){
			this.setStatus(Constants.getMessage("msgSuiteIsBeingPaused"), ViewHeaderLayout.INFO, Constants.getMessage("msgPauseWaitingForTestToComplete"));
			this._hideResumeButton();
			this.pauseButton.setDisabled(true);
		}else{
			this.clearStatus();
			this._hideResumeButton();
		}

		this._fetchRequestUpdates();
	},
		
	onBeforeClose: function(){
		if(!this._enabledResultButton)
			return true;
		else{
			return this._validateCustomAttributes(null);
		}
	},
	
	_updateBrowserTitle: function(){
		if (this.page){
			var name="";
		 	if (this.ergName) {
				name = this.ergName;
			}
			var tabTitle = Constants.getMessage("labelTestSuiteExecution", name);
			this.page.browserTitle =  tabTitle;
			dojo.publish(GlobalEvents.UpdateTabLabel, [window.location.hash, tabTitle, "",false]);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().setTitle(tabTitle);
			net.jazz.ajax.ui.PlatformUI.getWorkbench().browserTitle = tabTitle;	
		}
	}      
});
    
})();
